Code

cvsexportcommit: avoid racy CVS problem.
[git.git] / git-clone.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 die() {
12         echo >&2 "$@"
13         exit 1
14 }
16 usage() {
17         die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
18 }
20 get_repo_base() {
21         (
22                 cd "`/bin/pwd`" &&
23                 cd "$1" || cd "$1.git" &&
24                 {
25                         cd .git
26                         pwd
27                 }
28         ) 2>/dev/null
29 }
31 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
32     curl_extra_args="-k"
33 fi
35 http_fetch () {
36         # $1 = Remote, $2 = Local
37         curl -nsfL $curl_extra_args "$1" >"$2"
38 }
40 clone_dumb_http () {
41         # $1 - remote, $2 - local
42         cd "$2" &&
43         clone_tmp="$GIT_DIR/clone-tmp" &&
44         mkdir -p "$clone_tmp" || exit 1
45         if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
46                 "`git config --bool http.noEPSV`" = true ]; then
47                 curl_extra_args="${curl_extra_args} --disable-epsv"
48         fi
49         http_fetch "$1/info/refs" "$clone_tmp/refs" ||
50                 die "Cannot get remote repository information.
51 Perhaps git-update-server-info needs to be run there?"
52         test "z$quiet" = z && v=-v || v=
53         while read sha1 refname
54         do
55                 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
56                 case "$name" in
57                 *^*)    continue;;
58                 esac
59                 case "$bare,$name" in
60                 yes,* | ,heads/* | ,tags/*) ;;
61                 *)      continue ;;
62                 esac
63                 if test -n "$use_separate_remote" &&
64                    branch_name=`expr "z$name" : 'zheads/\(.*\)'`
65                 then
66                         tname="remotes/$origin/$branch_name"
67                 else
68                         tname=$name
69                 fi
70                 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
71         done <"$clone_tmp/refs"
72         rm -fr "$clone_tmp"
73         http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
74         rm -f "$GIT_DIR/REMOTE_HEAD"
75         if test -f "$GIT_DIR/REMOTE_HEAD"; then
76                 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
77                 case "$head_sha1" in
78                 'ref: refs/'*)
79                         ;;
80                 *)
81                         git-http-fetch $v -a "$head_sha1" "$1" ||
82                         rm -f "$GIT_DIR/REMOTE_HEAD"
83                         ;;
84                 esac
85         fi
86 }
88 quiet=
89 local=no
90 use_local=no
91 local_shared=no
92 unset template
93 no_checkout=
94 upload_pack=
95 bare=
96 reference=
97 origin=
98 origin_override=
99 use_separate_remote=t
100 depth=
101 no_progress=
102 test -t 1 || no_progress=--no-progress
103 while
104         case "$#,$1" in
105         0,*) break ;;
106         *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
107         *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
108           no_checkout=yes ;;
109         *,--na|*,--nak|*,--nake|*,--naked|\
110         *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
111         *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
112         *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
113           local_shared=yes; use_local=yes ;;
114         1,--template) usage ;;
115         *,--template)
116                 shift; template="--template=$1" ;;
117         *,--template=*)
118           template="$1" ;;
119         *,-q|*,--quiet) quiet=-q ;;
120         *,--use-separate-remote) ;;
121         *,--no-separate-remote)
122                 die "clones are always made with separate-remote layout" ;;
123         1,--reference) usage ;;
124         *,--reference)
125                 shift; reference="$1" ;;
126         *,--reference=*)
127                 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
128         *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
129                 case "$2" in
130                 '')
131                     usage ;;
132                 */*)
133                     die "'$2' is not suitable for an origin name"
134                 esac
135                 git check-ref-format "heads/$2" ||
136                     die "'$2' is not suitable for a branch name"
137                 test -z "$origin_override" ||
138                     die "Do not give more than one --origin options."
139                 origin_override=yes
140                 origin="$2"; shift
141                 ;;
142         1,-u|1,--upload-pack) usage ;;
143         *,-u|*,--upload-pack)
144                 shift
145                 upload_pack="--upload-pack=$1" ;;
146         *,--upload-pack=*)
147                 upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
148         1,--depth) usage;;
149         *,--depth)
150                 shift
151                 depth="--depth=$1";;
152         *,-*) usage ;;
153         *) break ;;
154         esac
155 do
156         shift
157 done
159 repo="$1"
160 test -n "$repo" ||
161     die 'you must specify a repository to clone.'
163 # --bare implies --no-checkout and --no-separate-remote
164 if test yes = "$bare"
165 then
166         if test yes = "$origin_override"
167         then
168                 die '--bare and --origin $origin options are incompatible.'
169         fi
170         no_checkout=yes
171         use_separate_remote=
172 fi
174 if test -z "$origin"
175 then
176         origin=origin
177 fi
179 # Turn the source into an absolute path if
180 # it is local
181 if base=$(get_repo_base "$repo"); then
182         repo="$base"
183         local=yes
184 fi
186 dir="$2"
187 # Try using "humanish" part of source repo if user didn't specify one
188 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 [ -e "$dir" ] && die "destination directory '$dir' already exists."
190 [ yes = "$bare" ] && unset GIT_WORK_TREE
191 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
192 die "working tree '$GIT_WORK_TREE' already exists."
193 D=
194 W=
195 cleanup() {
196         err=$?
197         test -z "$D" && rm -rf "$dir"
198         test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
199         cd ..
200         test -n "$D" && rm -rf "$D"
201         test -n "$W" && rm -rf "$W"
202         exit $err
204 trap cleanup 0
205 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
206 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
207 W=$(cd "$GIT_WORK_TREE" && pwd) && export GIT_WORK_TREE="$W"
208 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
209         GIT_DIR="$D"
210 else
211         GIT_DIR="$D/.git"
212 fi &&
213 export GIT_DIR &&
214 git-init $quiet ${template+"$template"} || usage
216 if test -n "$reference"
217 then
218         ref_git=
219         if test -d "$reference"
220         then
221                 if test -d "$reference/.git/objects"
222                 then
223                         ref_git="$reference/.git"
224                 elif test -d "$reference/objects"
225                 then
226                         ref_git="$reference"
227                 fi
228         fi
229         if test -n "$ref_git"
230         then
231                 ref_git=$(cd "$ref_git" && pwd)
232                 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
233                 (
234                         GIT_DIR="$ref_git" git for-each-ref \
235                                 --format='%(objectname) %(*objectname)'
236                 ) |
237                 while read a b
238                 do
239                         test -z "$a" ||
240                         git update-ref "refs/reference-tmp/$a" "$a"
241                         test -z "$b" ||
242                         git update-ref "refs/reference-tmp/$b" "$b"
243                 done
244         else
245                 die "reference repository '$reference' is not a local directory."
246         fi
247 fi
249 rm -f "$GIT_DIR/CLONE_HEAD"
251 # We do local magic only when the user tells us to.
252 case "$local,$use_local" in
253 yes,yes)
254         ( cd "$repo/objects" ) ||
255                 die "-l flag seen but repository '$repo' is not local."
257         case "$local_shared" in
258         no)
259             # See if we can hardlink and drop "l" if not.
260             sample_file=$(cd "$repo" && \
261                           find objects -type f -print | sed -e 1q)
263             # objects directory should not be empty since we are cloning!
264             test -f "$repo/$sample_file" || exit
266             l=
267             if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
268             then
269                     l=l
270             fi &&
271             rm -f "$GIT_DIR/objects/sample" &&
272             cd "$repo" &&
273             find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
274             ;;
275         yes)
276             mkdir -p "$GIT_DIR/objects/info"
277             echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
278             ;;
279         esac
280         git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
281         ;;
282 *)
283         case "$repo" in
284         rsync://*)
285                 case "$depth" in
286                 "") ;;
287                 *) die "shallow over rsync not supported" ;;
288                 esac
289                 rsync $quiet -av --ignore-existing  \
290                         --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
291                 exit
292                 # Look at objects/info/alternates for rsync -- http will
293                 # support it natively and git native ones will do it on the
294                 # remote end.  Not having that file is not a crime.
295                 rsync -q "$repo/objects/info/alternates" \
296                         "$GIT_DIR/TMP_ALT" 2>/dev/null ||
297                         rm -f "$GIT_DIR/TMP_ALT"
298                 if test -f "$GIT_DIR/TMP_ALT"
299                 then
300                     ( cd "$D" &&
301                       . git-parse-remote &&
302                       resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
303                     while read alt
304                     do
305                         case "$alt" in 'bad alternate: '*) die "$alt";; esac
306                         case "$quiet" in
307                         '')     echo >&2 "Getting alternate: $alt" ;;
308                         esac
309                         rsync $quiet -av --ignore-existing  \
310                             --exclude info "$alt" "$GIT_DIR/objects" || exit
311                     done
312                     rm -f "$GIT_DIR/TMP_ALT"
313                 fi
314                 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
315                 ;;
316         https://*|http://*|ftp://*)
317                 case "$depth" in
318                 "") ;;
319                 *) die "shallow over http or ftp not supported" ;;
320                 esac
321                 if test -z "@@NO_CURL@@"
322                 then
323                         clone_dumb_http "$repo" "$D"
324                 else
325                         die "http transport not supported, rebuild Git with curl support"
326                 fi
327                 ;;
328         *)
329                 case "$upload_pack" in
330                 '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
331                 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
332                 esac >"$GIT_DIR/CLONE_HEAD" ||
333                         die "fetch-pack from '$repo' failed."
334                 ;;
335         esac
336         ;;
337 esac
338 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
340 if test -f "$GIT_DIR/CLONE_HEAD"
341 then
342         # Read git-fetch-pack -k output and store the remote branches.
343         if [ -n "$use_separate_remote" ]
344         then
345                 branch_top="remotes/$origin"
346         else
347                 branch_top="heads"
348         fi
349         tag_top="tags"
350         while read sha1 name
351         do
352                 case "$name" in
353                 *'^{}')
354                         continue ;;
355                 HEAD)
356                         destname="REMOTE_HEAD" ;;
357                 refs/heads/*)
358                         destname="refs/$branch_top/${name#refs/heads/}" ;;
359                 refs/tags/*)
360                         destname="refs/$tag_top/${name#refs/tags/}" ;;
361                 *)
362                         continue ;;
363                 esac
364                 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
365         done < "$GIT_DIR/CLONE_HEAD"
366 fi
368 if test -n "$W"; then
369         cd "$W" || exit
370 else
371         cd "$D" || exit
372 fi
374 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
375 then
376         # a non-bare repository is always in separate-remote layout
377         remote_top="refs/remotes/$origin"
378         head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
379         case "$head_sha1" in
380         'ref: refs/'*)
381                 # Uh-oh, the remote told us (http transport done against
382                 # new style repository with a symref HEAD).
383                 # Ideally we should skip the guesswork but for now
384                 # opt for minimum change.
385                 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
386                 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
387                 ;;
388         esac
390         # The name under $remote_top the remote HEAD seems to point at.
391         head_points_at=$(
392                 (
393                         test -f "$GIT_DIR/$remote_top/master" && echo "master"
394                         cd "$GIT_DIR/$remote_top" &&
395                         find . -type f -print | sed -e 's/^\.\///'
396                 ) | (
397                 done=f
398                 while read name
399                 do
400                         test t = $done && continue
401                         branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
402                         if test "$head_sha1" = "$branch_tip"
403                         then
404                                 echo "$name"
405                                 done=t
406                         fi
407                 done
408                 )
409         )
411         # Upstream URL
412         git config remote."$origin".url "$repo" &&
414         # Set up the mappings to track the remote branches.
415         git config remote."$origin".fetch \
416                 "+refs/heads/*:$remote_top/*" '^$' &&
418         # Write out remote.$origin config, and update our "$head_points_at".
419         case "$head_points_at" in
420         ?*)
421                 # Local default branch
422                 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
424                 # Tracking branch for the primary branch at the remote.
425                 git update-ref HEAD "$head_sha1" &&
427                 rm -f "refs/remotes/$origin/HEAD"
428                 git symbolic-ref "refs/remotes/$origin/HEAD" \
429                         "refs/remotes/$origin/$head_points_at" &&
431                 git config branch."$head_points_at".remote "$origin" &&
432                 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
433                 ;;
434         '')
435                 # Source had detached HEAD pointing nowhere
436                 git update-ref --no-deref HEAD "$head_sha1" &&
437                 rm -f "refs/remotes/$origin/HEAD"
438                 ;;
439         esac
441         case "$no_checkout" in
442         '')
443                 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
444                 git read-tree -m -u $v HEAD HEAD
445         esac
446 fi
447 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
449 trap - 0